/******************************************************************************/
/*
                                  options.h
*/
/******************************************************************************/

#ifndef INCLUDE_OPTIONS_H
#define INCLUDE_OPTIONS_H

/***********/
/* defines */
/***********/

#define OPTIONS_CHECK_NEW 15
#define OPTIONS_FONT_SIZE 10
#define OPTIONS_ITEMS_PER_PAGE 10
#define OPTIONS_LANGUAGE "en"
#define OPTIONS_PER_PAGE 20
#define OPTIONS_QUOTE_FORWARD ""
#define OPTIONS_QUOTE_REPLY "> "
#define OPTIONS_THEME "default"
#define OPTIONS_WRAP_AT 78

/* show messages read history with asterisk */
#define OPTIONS_READ_HISTORY_ASTER  1
/* show messages read history with negative number */
#define OPTIONS_READ_HISTORY_NUMBER 2

/* message read preferences */
#define OPTIONS_READ_PLAIN1_HTML0 10
#define OPTIONS_READ_PLAIN1_HTML2 12
#define OPTIONS_READ_PLAIN2_HTML1 21
/* only used to 'probe' whether an HTML alternative is present! */
#define OPTIONS_READ_PLAIN0_HTML1 01

/* signature file options */
#define OPTIONS_SOY_SIGFILE_NONE      0
#define OPTIONS_SOY_SIGFILE_DEFAULT   1
#define OPTIONS_SOY_SIGFILE_SOYMAIL   2
#define OPTIONS_SOY_SIGFILE_NAME      3

#define SOYMAIL_SIGNATURE_NAME "SOYMAIL_SIGNATURE_"
#define SOYMAIL_SIGNATURE_SIZE (sizeof(SOYMAIL_SIGNATURE_NAME)-1)

/**************/
/* prototypes */
/**************/

void OptionsLoadSoy (REQUEST_DATA*);
void OptionsMunge (USER_OPTIONS*);
void OptionsPage (REQUEST_DATA*);
void OptionsParse (USER_OPTIONS*, char*);
BOOL OptionsPageRequest (REQUEST_DATA*);
void OptionsPublicGet (REQUEST_DATA*);
void OptionsPersonalYouGotMail (REQUEST_DATA*);
void OptionsSaveApplyRestore (BOOL, BOOL);
int OptionsSelectFile (char*, char*, char*);
void OptionsSelectLanguage (USER_OPTIONS*);
void OptionsSigFile (REQUEST_DATA*, char*);
void OptionsSigFileLoad (REQUEST_DATA*, char*);
void OptionsSigFileSave (REQUEST_DATA*);
int OptionsSigSelectFile (REQUEST_DATA*, char*);
void OptionsSoyApplySave (REQUEST_DATA*, BOOL);
void OptionsSoyMail (REQUEST_DATA*);
void OptionsSoyName (char*, char*, BOOL);
BOOL OptionsUserOverride (char*);
void OptionsVms (REQUEST_DATA*);
void OptionsVmsSave (REQUEST_DATA*);

void OptionsSigFile2 (REQUEST_DATA*, char*);
void OptionsSoyMail2 (REQUEST_DATA*);
void OptionsSoyName2 (char*, char*, BOOL);

#endif /* INCLUDE_OPTIONS_H */

/******************************************************************************/

